App = {
  web3Provider: null,
  contracts: {},

  init: async function() {   	  
	  document.getElementById('newInfo').value = 0;
	  document.getElementById("valuestate").innerHTML = "5";	  
      return await App.initWeb3();
  },

  initWeb3: async function() {    
	  // Modern dapp browsers...
  if (window.ethereum) {
     App.web3Provider = window.ethereum;
     try {
         // Request account access
        await window.ethereum.request({ method: "eth_requestAccounts" });
     }  catch (error) {
        // User denied account access...
        console.error("User denied account access")
     }
   }
    // Legacy dapp browsers...
   else if (window.web3) {
         App.web3Provider = window.web3.currentProvider;
   }
        // If no injected web3 instance is detected, fall back to Ganache
   else {
      App.web3Provider = new Web3.providers.HttpProvider('http://localhost:7545');
   }
     web3 = new Web3(App.web3Provider);	
    return App.initContract();
  },
	

  initContract: function() { 	  
	  $.getJSON('dappbuyandsell.json', function(data) {
           // Get the necessary contract artifact file and instantiate
		  //it with @truffle/contract
      var BuyandsellArtifact = data;
      App.contracts.eject = TruffleContract(BuyandsellArtifact);
      // Set the provider for our contract
      App.contracts.eject.setProvider(App.web3Provider);      
      });
      return App.bindEventsProductvalue();	  
   },

  bindEventsProductvalue: function() {        
	  document.getElementById("vendedor").addEventListener("mousedown", 
	  App.handleProductvalue, false);
	  return App.bindEventsPurchase();
  },
	
   bindEventsPurchase: function() {      	  
	  document.getElementById("comprador").addEventListener("mousedown",
	  App.handlePurchase, false);
	  return App.bindEventsReception();	  
   },
	
   bindEventsReception: function() {      	  
	  document.getElementById("recepcion").addEventListener("mousedown",
	  App.handleReception, false);
	  return App.bindEventsRefundSeller();
   },
	
   bindEventsRefundSeller: function() {      
	  document.getElementById("refundseller").addEventListener("mousedown",
	  App.handleRefunseller, false);
   },	  	
  
  handleProductvalue: function() {    
	     var dato = document.getElementById('newInfo').value; 
	  	 dato *= 1000000000000000000;//Convierte ETH a WEI
	     var BuyandsellInstance;
         web3.eth.getAccounts(function(error, accounts) {
             if (error) {
                  console.log(error);
             }
             var account = accounts[0];
             App.contracts.eject.deployed().then(function(instance) {
                  BuyandsellInstance = instance;
                  // Execute adopt as a transaction by sending account
                  return BuyandsellInstance.ProductValue(dato, {from: account});
              }).then(function(result) {
                    //return App.AbortProcess();
              }).catch(function(err) {
                   console.log(err.message);
              });
         }); 	  
    },
	
	ViewFlowStatus: function() {
      var BuyandsellInstance;
      App.contracts.eject.deployed().then(function(instance) {
          BuyandsellInstance = instance;
          return BuyandsellInstance.getState.call();
      }).then(function(galleta) {
	       document.getElementById("valuestate").innerHTML = galleta;  	
      }).catch(function(err) {
          console.log(err.message);
      }); 	  
   },
	
	bindEventViewFlowStatus: function() {        
	  document.getElementById("statep").addEventListener("mousedown", 
	  App.ViewFlowStatus, false);
   },	
	
	handlePurchase: function() { 	    
	     var BuyandsellInstance;
         web3.eth.getAccounts(function(error, accounts) {
             if (error) {
                  console.log(error);
             }
             var account = accounts[0];
             App.contracts.eject.deployed().then(function(instance) {
                  BuyandsellInstance = instance;
                  // Execute adopt as a transaction by sending account
                  return BuyandsellInstance.confirmPurchase({from: account});
              }).then(function(result) {
                    //return App.ViewFlowStatus();
              }).catch(function(err) {
                   console.log(err.message);
              });
         }); 	  
    },
	
	
	handleReception: function() { 	    
	     var BuyandsellInstance;
         web3.eth.getAccounts(function(error, accounts) {
             if (error) {
                  console.log(error);
             }
             var account = accounts[0];
             App.contracts.eject.deployed().then(function(instance) {
                  BuyandsellInstance = instance;
                  // Execute adopt as a transaction by sending account
                  return BuyandsellInstance.confirmReceived({from: account});
              }).then(function(result) {
                    //return App.ViewFlowStatus();
              }).catch(function(err) {
                   console.log(err.message);
              });
         }); 	  
    },
	
	handleRefunseller: function() { 	    
	     var BuyandsellInstance;
         web3.eth.getAccounts(function(error, accounts) {
             if (error) {
                  console.log(error);
             }
             var account = accounts[0];
             App.contracts.eject.deployed().then(function(instance) {
                  BuyandsellInstance = instance;
                  // Execute adopt as a transaction by sending account
                  return BuyandsellInstance.refundSeller({from: account});
              }).then(function(result) {
                    //return App.ViewFlowStatus();
              }).catch(function(err) {
                   console.log(err.message);
              });
         }); 	  
    },
	
	ViewBalanceBuyer: function() {
      	var BuyandsellInstance;
      	App.contracts.eject.deployed().then(function(instance) {
          	BuyandsellInstance = instance;
          	return BuyandsellInstance.SeeBalancebuyer.call();
      	}).then(function(pardo) {
			document.getElementById("buyyyer_balan").innerHTML = pardo;  	
      	}).catch(function(err) {
          	console.log(err.message);
      	}); 	  
   	},
	
	BalancePurchase: function() {      	  
	  document.getElementById("balancebuyer").addEventListener("mousedown",
	  App.ViewBalanceBuyer, false);
   },	
	
	
   ViewBalanceSeller: function() {
      	var BuyandsellInstance;
      	App.contracts.eject.deployed().then(function(instance) {
          	BuyandsellInstance = instance;
          	return BuyandsellInstance.SeeBalanceseller.call();
      	}).then(function(felino) {
			document.getElementById("seller_balan").innerHTML = felino;  	
      	}).catch(function(err) {
          	console.log(err.message);
      	}); 	  
   	},
	
	BalanceSeller: function() {      	  
	  document.getElementById("balanceseller").addEventListener("mousedown",
	  App.ViewBalanceSeller, false);
   },	
	
   ViewBalanceContract: function() {
      	var BuyandsellInstance;
      	App.contracts.eject.deployed().then(function(instance) {
          	BuyandsellInstance = instance;
          	return BuyandsellInstance.SeeBalancecontract.call();
      	}).then(function(jaguart) {
			document.getElementById("contract_balan").innerHTML = jaguart;  	
      	}).catch(function(err) {
          	console.log(err.message);
      	}); 	  
   	},
	
	BalanceContract: function() {       
	  document.getElementById("balancecontract").addEventListener("mousedown", App.ViewBalanceContract, false);	
	},		
};

App.init();
App.BalancePurchase();
App.BalanceSeller();
App.BalanceContract();
App.bindEventViewFlowStatus();



